/*
  Tutanchamun, an arcade game
  Copyright (C) 1998  David Kastrup
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */
#include <string.h>
#include "tutan.h"
#include "tutdisp.h"
#include "tutsound.h"

int player;
playfieldt playfield[2];

void clrscr()
{
  d_rect(0,0,0,48,48);
}

void playms(int player)
{
  static char playtx[] = "PLAYER 1";
  playtx[7] = player+'1';
  clrscr();
  d_wrbig(playtx, 8, 16);
}

void plupms(int player)
{
  playms(player);
  sndpla();
  music();
}

void newplayer(int player)
{
  playfield[player].men = 4;
  strcpy(playfield[player].score, "     0");
  playfield[player].smarts = 1;
  playfield[player].nstage = 0;
}

void newstage(int player)
{
  static char stgmsg[] = "STAGE XX";
  char * const stagea = stgmsg + 6;
  int i;

  if (playfield[player].nstage == 96)
    playfield[player].nstage = 1;
  else
    ++playfield[player].nstage;
 
  stagea[0] = playfield[player].nstage < 10 ? ' '
    : '0' + playfield[player].nstage / 10;
  stagea[1] = '0' + playfield[player].nstage % 10;
  clrscr();
  d_wrbig(stgmsg,6,22);
  paus(2);
  
  playfield[player].stage = stages[(playfield[player].nstage-1)&0xf];
  memcpy(playfield[player].staga, playfield[player].stage.stagesrc,
	 playfield[player].stage.width*12);
  playfield[player].nbonus = 0;
  playfield[player].wkey = 0;
  for (i=0; i<2; ++i) {
    if (playfield[player].stage.addkey[i].x) {
      playfield[player].staga
	[playfield[player].stage.addkey[i].x/4]
	[playfield[player].stage.addkey[i].y/4] = SC;
      playfield[player].staga
	[playfield[player].stage.addkey[i].x/4-1]
	[playfield[player].stage.addkey[i].y/4] = SR;
      playfield[player].staga
	[playfield[player].stage.addhol[i].x/4]
	[playfield[player].stage.addhol[i].y/4] = LO;
      playfield[player].staga
	[playfield[player].stage.addhol[i].x/4-1]
	[playfield[player].stage.addhol[i].y/4] = LR;
    }
  }
}

void newscr(int player)
{
  int i;

  d_timedisplay(player, playfield[player].stage.time);
  colbak = playfield[player].stage.colbak;
  colfor = playfield[player].stage.colfor;
  bgstagesetup();
  mymcb.mph = playfield[player].wkey ? &manwmph : &manmph;
  mymcb.shape = mymcb.mph->shapri;
  for (i=1; i<12; i++) {
    mcbarr[i].next = &mcbarr[i+1];
  }
  freemcb = &mcbarr[1];
  nmons = 0;
  mymcb.flag = 0;
  mymcb.downcn = 1;
  mymcb.xcoor = playfield[player].stage.xman;
  mymcb.ycoor = playfield[player].stage.yman;
  if (mymcb.xcoor >= 24)
    scrx = mymcb.xcoor - 24 - 48;
  else
    scrx = 0 - 48;
  for (i=0; i<12; i++)
    scrlft();
  qstove();
  throwi(&mymcb);
  if (!demflg) {
    for (i=0; i<playfield[player].men; i++) {
      d_draman(i, manshd);
    }
    for (i=0; i<playfield[player].smarts && i<5; i++) {
      d_drasma(i, lampshd);
    }
    do {
    } while(d_joystc() == 0);
  }
  return;
}

void tutplay(int players)
{
  int activeplayers = 0;
  int i;

  player = 0;
  
  d_wrscore(0, "     0");
  d_wrscore(1, players > 1 ? "     0" : "      ");

  opensound();

  for (;;) {
    if (activeplayers < players) {
      plupms(player);
      newplayer(player);
      ++activeplayers;
      newstage(player);
    }
    for (;;) {
      newscr(player);
      switch (tutmain()) {
      case LOSE:
	d_clearmansma();
	if (playfield[player].men == 0) {
	  playms(player);
	  d_wrbig("GAME OVER",6,28);
	  sndovr();
	  music();
	  chkhig();
	} else if (mymcb.xcoor < 76) {
	  playfield[player].stage.xman = 28;
	  playfield[player].stage.yman = playfield[player].stage.y28;
	} else if (mymcb.xcoor < 152) {
	  playfield[player].stage.xman = 92;
	  playfield[player].stage.yman = playfield[player].stage.y92;
	} else if (mymcb.xcoor < 192) {
	  playfield[player].stage.xman = 152;
	  playfield[player].stage.yman = playfield[player].stage.y152;
	} else {
	  playfield[player].stage.xman = 220;
	  playfield[player].stage.yman = playfield[player].stage.y220;
	}
	if (activeplayers < players) {
	  player = !player;
	  break;
	}
	if (playfield[!player].men) {
	  player = !player;
	} else if (!playfield[player].men) {
	  closesound();
	  return;
	}
	--playfield[player].men;
	plupms(player);
	continue;
      case WIN:
	sndwin();
	for (i=0; i<24; ++i) {
	  d_opendoors(d_pictur[(playfield[player].nstage-1)&3],32,32,i);
	  music();
	}
	add100(10*(playfield[player].nstage-1)&3);
	while (timtab[TIMBYT].timebyte != DEAD_TIMER) {
	  timtab[TIMBYT].timebyte = 0;
	  timedo(&timtab[TIMBYT].timebyte);
	  add10(8);
	  sndtim();
	  music();
	}
	paus(5);
	newstage(player);
	continue;
      }
      break;
    }
  }
}

int demoplay()
{
  player = 0;
  newplayer(0);
  newstage(0);
  newscr(0);
  return tutmain();
}
        
void qstove()
{
  int i;

  for (i=0; i<7; ++i)
    playfield[player].stage.prodta[i].downcn = 0xff;
}
